/*
 * ex1.c : a simple module __with arguments__
 *
 * Copyright (C) 2001 Julien Gaulmin <julien.gaulmin@fr.alcove.com>, Alcve
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
 * USA or look at http://www.gnu.org/copyleft/gpl.html
 */


/*
 * Includes
 */

#include <linux/kernel.h>	/* printk() */
#include <linux/module.h>	/* modules */
#include <linux/init.h>		/* module_{init,exit}() */

#include "ex.h"


/*
 * Arguments
 */

static char *id = "ex1_default"; /* ID-String of the module */
static int num = 1234; /* A number */

MODULE_DESCRIPTION("Simple module __with arguments__ (ex1)");
MODULE_AUTHOR("Julien Gaulmin, Alcove");
MODULE_SUPPORTED_DEVICE("Nothing in particular");
MODULE_PARM_DESC(id, "ID-String of the driver");
MODULE_PARM_DESC(num, "A number");
MODULE_PARM(id, "1-" __MODULE_STRING(MAX_ID_SIZE) "s");
MODULE_PARM(num, "i");


/*
 * Init and Exit
 */

static int __init ex1_init(void)
{
	printk(KERN_INFO "ex1 initialization\n");
	printk(KERN_INFO "ex1 arguments : id=%s, num=%d\n", id, num);

	return 0;
}


static void __exit ex1_exit(void)
{
	printk(KERN_INFO "ex1 exit\n");
}


/*
 * Module entry points
 */

module_init(ex1_init);
module_exit(ex1_exit);
